<script lang="ts">
  import { getContext } from 'svelte'
  import { Writable } from 'svelte/store'

  import Resource from './Resource.svelte'
  import Dialog from '../Dialog.svelte'

  import type {
    ResourceListData,
    ResourceName,
  } from '../../module/model/character-data.js'
  import { getLocalizer } from '../../module/utils.js'
  import { CharacterDataAccessor } from '../../module/model/character.js'
  import ApplyDamage from '../apply-damage/ApplyDamage.svelte'
  import Rest from '../roll-dialog/RestRoll.svelte'
  import { Character } from '../../module/character/character.js'

  export let resources: ResourceListData<ResourceName>
  let doc = getContext<Writable<CharacterDataAccessor>>('doc')

  $: availableResources = [
    'vitality',
    'endurance',
    ...($doc.system.settings.hasKarmicEnergy ? ['karmicEnergy'] : []),
    ...($doc.system.settings.hasAstralEnergy ? ['astralEnergy'] : []),
  ]
  const localize = getLocalizer()

  let applyDamageDialog: Dialog
  let restDialog: Dialog
  const character = new Character($doc)

  function isBelowMax(resource) {
    return resource.value < resource.max
  }

  function openRestDialog() {
    if (
      isBelowMax(character.data.system.base.resources.vitality) ||
      (isBelowMax(character.data.system.base.resources.astralEnergy) &&
        character.data.system.settings.hasAstralEnergy)
    ) {
      restDialog.open()
    } else {
      ui?.notifications?.info(localize('completlyRestedNotification'))
    }
  }
</script>

<Dialog
  bind:this={applyDamageDialog}
  title={localize('applyDamage')}
  dialogComponent={ApplyDamage}
  {character}
  buttonLabel={localize('applyDamage')}
/>

<Dialog
  bind:this={restDialog}
  title={localize('rest')}
  dialogComponent={Rest}
  {character}
  buttonLabel={localize('rest')}
/>

<div class="container">
  <div class="resource-actions">
    <!-- svelte-ignore a11y-no-static-element-interactions a11y-missing-attribute -->
    <a
      on:click={applyDamageDialog.open}
      on:keydown={applyDamageDialog.open}
      data-testid="open-apply-damage-dialog"
      title={localize('applyDamage')}
    >
      <i class="fas fa-heart-circle-minus" />
    </a>
    <!-- svelte-ignore a11y-no-static-element-interactions a11y-missing-attribute -->
    <a
      on:click={openRestDialog}
      on:keydown={openRestDialog}
      data-testid="open-rest-dialog"
      title={localize('rest')}
    >
      <i class="fas fa-bed" />
    </a>
  </div>

  {#each availableResources as resourceName}
    <fieldset>
      <legend data-testid="label">{localize(resourceName)}</legend>
      <Resource bind:resource={resources[resourceName]} />
    </fieldset>
  {/each}
</div>

<style>
  .container a {
    font-size: 32px;
  }

  .resource-actions {
    display: flex;
    gap: 10px;
    justify-content: center;
  }

  .container {
    width: fit-content;
    text-align: center;
  }
</style>
